%global pkgvers 0
%global scdate0 20250117
%global schash0 4435a9ef89892757eaf703085606f10040da6bfe
%global branch0 master
%global source0 https://github.com/gtkwave/gtkwave.git

%global sshort0 %{expand:%%{lua:print(('%{schash0}'):sub(1,8))}}

Name:           gtkwave
Version:        %(curl -s https://raw.githubusercontent.com/gtkwave/gtkwave/%{schash0}/meson.build | grep -m1 version: | cut -d"'" -f2 | cut -d'-' -f1)
Release:        %{scdate0}.%{pkgvers}.git%{sshort0}%{?dist}
Summary:        Waveform Viewer
License:        GPLv2+

URL:            http://gtkwave.sourceforge.net

BuildRequires:  git meson cmake
BuildRequires:  bzip2-devel
BuildRequires:  coreutils
BuildRequires:  desktop-file-utils
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  flex
BuildRequires:  gedit
BuildRequires:  gperf
BuildRequires:  pkgconfig(gio-unix-2.0) >= 2.0
BuildRequires:  pkgconfig(gtk4) >= 4.0.0
BuildRequires:  pkgconfig(gtk+-3.0) >= 3.0.0
BuildRequires:  pkgconfig(gtk+-unix-print-3.0)
BuildRequires:  pkgconfig(libtirpc)
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  hicolor-icon-theme
BuildRequires:  libappstream-glib
BuildRequires:  make
BuildRequires:  shared-mime-info
BuildRequires:  tcl-devel >= 8.4
BuildRequires:  tk-devel
BuildRequires:  xz-devel
BuildRequires:  zlib-devel
%if 0%{?fedora}
BuildRequires:  Judy-devel
%endif

# Dependencies
Requires:       hicolor-icon-theme
Requires:       shared-mime-info

# Judy-devel missing on EL-8 s390x
# https://lists.fedoraproject.org/archives/list/epel-devel@lists.fedoraproject.org/thread/O4JISZYIVXXPIB6OZIE2TNKR2EIQZWBL/
%if 0%{?el8}
ExcludeArch:    s390x
%endif

%description
GTKWave is a waveform viewer that can view VCD files produced by most Verilog
simulation tools, as well as LXT files produced by certain Verilog simulation
tools.

%package devel
Summary:  Waveform Viewer Development
Requires: %{name}

%description devel
Development headers for %{name}.


%prep
%setup -T -c -n %{name}
git clone --depth 1 -n -b %{branch0} %{source0} .
git fetch --depth 1 origin %{schash0}
git reset --hard %{schash0}
git log --format=fuller
# meson version
sed -i "s|meson_version: .*|meson_version: '>= 0.58',|" meson.build
sed -i "s|glib_req = .*|glib_req = '>=2.54.0'|" meson.build
sed -i "s|GLIB_VERSION_._..|GLIB_VERSION_2_54|" meson.build
sed -i "s|gtk_req = .*|gtk_req = '>=3.22.0'|" meson.build
# rpath
sed -i "s|install_rpath = .*|install_rpath = ''|" meson.build
# gcc fixes
sed -i "1i #include <stdint.h>" src/tree.h
# rhel fixes
%if 0%{?rhel}
sed -i "s|G_OPTION_ENTRY_NULL|\{ NULL \}|g" contrib/rtlbrowse/main.c
%endif


%build
%if 0%{?rhel}
export LDFLAGS="-Wl,--copy-dt-needed-entries"
%meson -Djudy=disabled -Dset_rpath=disabled
%else
%meson
%endif
%meson_build


%install
%meson_install


%files
%license LICENSE*
%doc AUTHORS
%doc %{_datadir}/gtkwave3/*
%{_bindir}/*
%{_libdir}/*
%{_datadir}/applications/*.desktop
%dir %{_datadir}/icons/hicolor/scalable/apps
%dir %{_datadir}/icons/hicolor/symbolic/apps
%{_datadir}/icons/hicolor/scalable/apps/*.svg
%{_datadir}/icons/hicolor/symbolic/apps/*.svg
%{_datadir}/mime/packages/*.xml
%{_datadir}/metainfo/*.xml
%{_datadir}/gir-1.0/*.gir
%{_mandir}/man?/*.?*

%files devel
%{_includedir}/*


%changelog
* Sun Jul 25 2021 Cristian Balint <cristian.balint@gmail.com>
- update github releases

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.3.108-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild
